<?php
/**
 * @version		2.7.0
 * @package		Joomla
 * @subpackage	Joom Donation
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
class JoomDonationHelper {
	/**
	 * Get configuration data and store in config object
	 *
	 * @return object
	 */
	function getConfig($nl2br = true) {
		static  $config ;
		if (!$config) {
			$db = & JFactory::getDBO();
			$config = new stdClass ;
			$sql = 'SELECT * FROM #__jd_configs';
			$db->setQuery($sql);
			$rows = $db->loadObjectList();
			for ($i = 0 , $n = count($rows); $i < $n; $i++) {
				$row = $rows[$i];
				$key = $row->config_key;
				$value = stripslashes($row->config_value);
				if ($nl2br)
					$value = nl2br($value); 
				$config->$key = $value;	
			}			
		}			
		return $config;
	}
	/**
	 * Get specify config value
	 *
	 * @param string $key
	 */
	function getConfigValue($key) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT config_value FROM #__jd_configs WHERE config_key="'.$key.'"';
		$db->setQuery($sql) ;
		return $db->loadResult();
	}	
	/**
	 * Get Itemid of Joom Donation
	 *
	 * @return int
	 */
	function getItemid() {
		$db = & JFactory::getDBO();
		$sql = "SELECT id FROM #__menu WHERE link LIKE '%index.php?option=com_jdonation%'";
		$db->setQuery($sql) ;
		$itemId = $db->loadResult();		
		if (!$itemId) {
			global $Itemid ;
			if ($Itemid == 1)
				$itemId = 999999 ;
			else 
				$itemId = $Itemid ;	
		}			
		return $itemId ;	
	}
	/**
	 * Load language from main component
	 *
	 */
	function loadLanguage() {
		static $loaded ;
		if (!$loaded) {
			$lang = & JFactory::getLanguage() ;
			$tag = $lang->getTag();
			if (!$tag)
				$tag = 'en-GB' ;
			$lang->load('com_jdonation', JPATH_ROOT, $tag);
			$loaded = true ;	
		}		
	}	
	/**
	 * Get country code
	 *
	 * @param string $countryName
	 * @return string
	 */
	function getCountryCode($countryName) {
		$db = & JFactory::getDBO() ;
		$sql = 'SELECT country_2_code FROM #__jd_countries WHERE LOWER(name)="'.JString::strtolower($countryName).'"';
		$db->setQuery($sql) ;
		$countryCode = $db->loadResult();
		if (!$countryCode)
			$countryCode = 'US' ;
		return $countryCode ;		
	}	
	/**
	 * Send notification emails to administrators and confirmation email to donor
	 *
	 * @param object $row
	 * @param object $config
	 */
	function sendEmails($row, $config) {
		$db = JFactory::getDBO() ;
		$jconfig = new JConfig();
		$fromEmail =  $jconfig->mailfrom;
		$fromName = $jconfig->fromname;	
		$siteName = $jconfig->sitename ;	
		$emailContent =  JoomDonationHelper::getEmailContent($config, $row);		
		$replaces = array() ;
		//Get campaign name			
		$sql = "SELECT title FROM #__jd_campaigns WHERE id=".$row->campaign_id;
		$db->setQuery($sql) ;
		$campaign = $db->loadResult();
		$replaces['campaign'] = $campaign ;				
		$replaces['first_name'] = $row->first_name ;
		$replaces['last_name'] = $row->last_name ;
		$replaces['organization'] = $row->organization ;
		$replaces['address'] = $row->address ;
		$replaces['address2'] = $row->address ;
		$replaces['city'] = $row->city ;
		$replaces['state'] = $row->state ;
		$replaces['zip'] = $row->zip ;
		$replaces['country'] = $row->country ;
		$replaces['phone'] = $row->phone ;
		$replaces['fax'] = $row->phone ;
		$replaces['email'] = $row->email ;
		$replaces['comment'] = $row->comment ;
		$replaces['amount'] = number_format($row->amount, 2) ;
		$replaces['transaction_id'] = $row->transaction_id ;		  	
		//Get custom fields
		$sql = 'SELECT * FROM #__jd_fields WHERE published=1';
		$db->setQuery($sql) ;
		$rowFields = $db->loadObjectList();
		$fields = array() ;
		for ($i = 0 , $n = count($rowFields) ; $i < $n ; $i++) {
			$rowField = $rowFields[$i] ;
			$fields[$rowField->id] = $rowField->name ;
		}
		$sql = 'SELECT field_id, field_value FROM #__jd_field_value WHERE donor_id = '.$row->id;
		$db->setQuery($sql) ;
		$rowValues = $db->loadObjectList();
		$values = array() ;
		for ($i = 0 , $n = count($rowValues) ; $i < $n ; $i++) {
			$rowValue = $rowValues[$i] ;
			$values[$rowValue->field_id] = $rowValue->field_value ;
		}
		if (count($values)) {
			foreach ($values as $key => $value) {				
				$replaces[strtoupper($fields[$key])] = $value ;		
			}
		}
		//Over-ridde email message
		if ($row->campaign_id) {
			$sql = 'SELECT * FROM #__jd_campaigns WHERE id='.$row->campaign_id ;
			$db->setQuery($sql) ;
			$rowCampaign = $db->loadObject();
			if ($rowCampaign->user_email_subject)
				$config->user_email_subject = $rowCampaign->user_email_subject;
			if ($rowCampaign->user_email_body)
				$config->user_email_body = $rowCampaign->user_email_body ;
			if ($rowCampaign->notification_emails) 
				$config->notification_emails = $rowCampaign->notification_emails ;		
		}		
		//Notification email send to user
		$subject = $config->user_email_subject;
		if ($row->payment_method == 'os_offline') {
			$body = nl2br($config->user_email_body_offline);
		} else {			
			$body = nl2br($config->user_email_body);	
		}			
		$body = str_replace('[DONATION_DETAIL]', $emailContent, $body) ;
		foreach ($replaces as $key=>$value) {
			$key = strtoupper($key) ;
			$body = str_replace("[$key]", $value, $body) ;
		}																				
		JUtility::sendMail($fromEmail, $fromName, $row->email, $subject, $body, 1);				
		if ($row->receive_user_id) {
			//Send a CC email to administrator			
			$sql = 'SELECT * FROM #__users WHERE id='.$row->receive_user_id ;
			$db->setQuery($sql) ;
			$rowUser = $db->loadObject() ;
			if ($rowUser) {
				$subject = $config->member_email_subject;
				$body = nl2br($config->member_email_body);	
				$receiveEmail = $row->email ;
				$name = $row->name ;				
				$body = str_replace('[DONATION_DETAIL]', $emailContent, $body) ;
				$body = str_replace('[NAME]', $name, $body) ;
				$body = str_replace('[SITE_NAME]', $siteName, $body) ;
				foreach ($replaces as $key=>$value) {
					$key = strtoupper($key) ;
					$body = str_replace("[$key]", $value, $body) ;
				}
				JUtility::sendMail($fromEmail, $fromName, $receiveEmail, $subject, $body, 1);
			}					
		}
		//Send emails to notification emails
		if ($config->notification_emails == '')	
			$notificationEmails = $fromEmail;
		else 
			$notificationEmails = $config->notification_emails;
		$notificationEmails = str_replace(' ', '', $notificationEmails);
		$emails = explode(',', $notificationEmails);
		$subject = $config->admin_email_subject ;
		$body = $config->admin_email_body;
		$body =  nl2br($body);
		$body = str_replace('[DONATION_DETAIL]', $emailContent, $body);
		foreach ($replaces as $key=>$value) {
			$key = strtoupper($key) ;
			$body = str_replace("[$key]", $value, $body) ;
		}
		for ($i = 0, $n  = count($emails); $i < $n ; $i++) {
			$email = $emails[$i];
			JUtility::sendMail($fromEmail, $fromName, $email, $subject, $body, 1);					
		}
	}
	/**
	 * Get email content for sending to administrator
	 *
	 * @param  object $config : containing configuration data
	 * $param Object $row : containing donation record detail 
	 */
	function getEmailContent($config, $row) {
		$db = & JFactory::getDBO() ;	
		$sql = 'SELECT title FROM #__jd_campaigns WHERE id='.$row->campaign_id ;
		$db->setQuery($sql) ;
		$campaignTitle = $db->loadResult();			
		$table = "<table width=\"100%\" cellspacing=\"5\" cellspacing=\"5\"";
		if ($config->use_campaign) {
			$table .=				
					"	<tr>
							<td>
								"
									.JText::_('Campaign:').
								"								
							</td>
							<td>
								$campaignTitle
							</td>
						</tr>
					" ;					
		}		
		$table .= "		<tr>
							<td>
								"
									.JText::_('JD_FIRST_NAME').
								"								
							</td>
							<td>
								$row->first_name
							</td>
						</tr>";			
		if ($config->s_lastname) {
			$table .= "				
						<tr>
							<td>
								"
								.JText::_('JD_LAST_NAME').
								"
							</td>
							<td>
								$row->last_name
							</td>
						</tr>												
				";						
		}			
		if ($config->s_organization) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_ORGANIZATION').
								"
							</td>
							<td>
								$row->organization
							</td>
						</tr>						
					";					
		}
		if ($config->s_address) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_ADDRESS').
								"
							</td>
							<td>
								$row->address
							</td>
						</tr>						
					";					
		}				
		if ($config->s_city) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_CITY').
								"
							</td>
							<td>
								$row->city
							</td>
						</tr>						
					";											
		}
		if ($config->s_state) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_STATE').
								"
							</td>
							<td>
								$row->state
							</td>
						</tr>						
					";											
		}
		if ($config->s_zip) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_ZIP').
								"
							</td>
							<td>
								$row->zip
							</td>
						</tr>						
					";											
		}
		if ($config->s_country) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_COUNTRY').
								"
							</td>
							<td>
								$row->country
							</td>
						</tr>						
					";											
		}
		if ($config->s_phone) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_PHONE').
								"
							</td>
							<td>
								$row->phone
							</td>
						</tr>						
					";											
		}
		$table.="
					<tr>
						<td>
							"
							.JText::_('JD_EMAIL').
							"
						</td>
						<td>
							$row->email
						</td>
					</tr>						
				";							
					
		if ($row->donation_type == 'I') {
			$donationType = JText::_('JD_ONETIME') ;			
		} else {
			$donationType = JText::_('JD_RECURRING') ;
		}

		$table.="
					<tr>
						<td>
							"
							.JText::_('JD_DONATION_TYPE').
							"
						</td>
						<td>
							"
							.$donationType.
							"							
						</td>
					</tr>						
				";	
		
		$table.="
					<tr>
						<td>
							"
							.JText::_('JD_DONATION_AMOUNT').
							"
						</td>
						<td>
							"
							.number_format($row->amount, 2).
							"							
						</td>
					</tr>						
				";
		if ($row->donation_type == 'R') {
			switch ($row->r_frequency) {
				case 'd' :
					$frequency =  JText::_('JD_DAILY') ;
					break ;
				case 'w' :
					$frequency = JText::_('JD_WEEKLY') ;
					break ;
				case 'm' :
					$frequency = JText::_('JD_MONTHLY') ;
					break ;
				case 'q' :
					$frequency = JText::_('JD_QUARTERLY') ;
					break ;
				case 's' :
					$frequency = JText::_('JD_SEMI_ANNUALLY') ;
					break ;
				case 'a' :
					$frequency = JText::_('JD_ANNUALLY') ;
					break ;
				default:
					$frequency = '';				 								
			}
			
			$table.="
					<tr>
						<td>
							"
							.JText::_('JD_FREQUENCY').
							"
						</td>
						<td>
							"
							.$frequency.
							"							
						</td>
					</tr>						
				";

			if ($row->r_times) {
				$table.="
					<tr>
						<td>
							"
							.JText::_('JD_NUMBER_DONATIONS').
							"
						</td>
						<td>
							"
							.$row->r_times.
							"							
						</td>
					</tr>						
				";				
			}
		}
		$table.="
					<tr>
						<td>
							"
							.JText::_('JD_PAYMENT_OPTION').
							"
						</td>
						<td>
							"
							.JText::_(strtoupper($row->payment_method)).
							"							
						</td>
					</tr>						
				";
		$table.="
					<tr>
						<td>
							"
							.JText::_('JD_TRANSACTION_ID').
							"
						</td>
						<td>
							"
							.$row->transaction_id.
							"							
						</td>
					</tr>						
				";					
		$jcFields = new JCFields();
		if ($jcFields->getTotal()) {
			//We will include custom fields in email content
			$db = & JFactory::getDBO();
			$sql = 'SELECT field_id, field_value FROM #__jd_field_value WHERE donor_id='.$row->id;
			$db->setQuery($sql);
			$rowFields = $db->loadObjectList();
			$values = array() ;
			for ($i = 0, $n = count($rowFields) ; $i < $n; $i++) {
				$rowField = $rowFields[$i] ;
				$values[$rowField->field_id] = $rowField->field_value ;	
			}
			for ($i = 0, $n = count($jcFields->_fields) ; $i < $n; $i++) {
				$field = $jcFields->_fields[$i] ;
				if (isset($values[$field->id]))
					$value = $values[$field->id] ;
				else 	
					$value = '' ;			
				$table.="
					<tr>
						<td>
							"
							.$field->title.
							"
						</td>
						<td>							
							$value														
						</td>
					</tr>						
				";							
			}
		}					
		if ($config->s_comment) {
			$table.="
						<tr>
							<td>
								"
								.JText::_('JD_COMMENT').
								"
							</td>
							<td>
								$row->comment
							</td>
						</tr>						
					";											
		}	
		$table.="</table>";						
		return $table;	
	}	
	/**
	 * Send recurring email
	 *
	 * @param object $row
	 * @param object $config
	 */		
	function sendRecurringEmail($row, $config) {
		$db = & JFactory::getDBO();
		$jconfig = new JConfig();
		$fromEmail =  $jconfig->mailfrom;
		$fromName = $jconfig->fromname;		
		$siteName = $jconfig->sitename ;
		$amount = JRequest::getVar('receive_amount', '') ;
		if ($amount == '')
			$amount = $row->amount ;	
		if ($row->campaign_id) {
			$sql = 'SELECT * FROM #__jd_campaigns WHERE id='.$row->campaign_id ;
			$db->setQuery($sql) ;
			$rowCampaign = $db->loadObject();
			if ($rowCampaign->recurring_email_subject)
				$config->recurring_email_subject = $rowCampaign->recurring_email_subject;
			if ($rowCampaign->recurring_email_body)
				$config->recurring_email_body = $rowCampaign->recurring_email_body ;
			if ($rowCampaign->notification_emails) 
				$config->notification_emails = $rowCampaign->notification_emails ;		
		}			
		//Notification email send to user
		$subject = $config->recurring_email_subject;
		$body = nl2br($config->recurring_email_body);				
		//Replace some information in the body
		$body = str_replace('[DONATION_AMOUNT]', number_format($amount, 2), $body);
		$detailLink = JURI::base().'/administrator/index.php?option=com_jdonation&task=edit&cid[]='.$row->id ;
		$body = str_replace('[DETAIL_LINK]', $detailLink, $body) ;				
		if ($config->notification_emails == '')	
			$notificationEmails = $fromEmail;
		else 
			$notificationEmails = $config->notification_emails;
		$notificationEmails = str_replace(' ', '', $notificationEmails);
		$emails = explode(',', $notificationEmails);		
		for ($i = 0, $n  = count($emails); $i < $n ; $i++) {
			$email = $emails[$i];
			JUtility::sendMail($fromEmail, $fromName, $email, $subject, $body, 1);					
		}		
		if ($row->receive_user_id) {			
			$sql = 'SELECT * FROM #__users WHERE id='.$row->receive_user_id ;
			$db->setQuery($sql) ;
			$rowUser = $db->loadObject();
			if ($rowUser) {
				$name = $row->name ;
				$receiveEmail = $row->email ;
				$subject = $config->member_recurring_email_subject;
				$body = nl2br($config->member_recurring_email_body);
				$body = str_replace('[AMOUNT]', number_format($amount, 2), $body);			
				$body = str_replace('[SITE_NAME]', $siteName, $body);
				$body = str_replace('[NAME]', $name, $body);
				JUtility::sendMail($fromEmail, $fromName, $receiveEmail, $subject, $body, 1);													
			}									
		}		
	}	
}
?>